Index: src/sas/guiframe/local_perspectives/data_loader/data_loader.py
===================================================================
--- src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision b3efb7dfc293a955756eccf52e0bbd30d3a2c32d)
+++ src/sas/guiframe/local_perspectives/data_loader/data_loader.py	(revision b45cde35d36e3d241e3ee1427715d7ff31251ea7)
@@ -233,5 +233,5 @@
                 error_message += "Make sure the content of your file"
                 error_message += " is properly formatted.\n\n"
-                error_message += "When contacting the DANSE team, mention the"
+                error_message += "When contacting the SasView team, mention the"
                 error_message += " following:\n%s" % str(error)
             elif data_error:
Index: src/sas/guiframe/local_perspectives/plotting/AnnulusSlicer.py
===================================================================
--- src/sas/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ src/sas/guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 400155bab01bdb35b3cf83069f57cf9f47005bca)
@@ -35,5 +35,5 @@
     
         ## Number of points on the plot
-        self.nbins = 20
+        self.nbins = 36
         #Cursor position of Rings (Left(-1) or Right(1))
         self.xmaxd = self.base.data2D.xmax
@@ -131,7 +131,7 @@
                    math.fabs(self.outer_circle.get_radius()))
         #if the user does not specify the numbers of points to plot 
-        # the default number will be nbins= 20
+        # the default number will be nbins= 36
         if nbins == None:
-            self.nbins = 20
+            self.nbins = 36
         else:
             self.nbins = nbins
Index: src/sas/guiframe/media/Graph_help.html
===================================================================
--- src/sas/guiframe/media/Graph_help.html	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,122 +1,0 @@
-<html>
-<body>
-
-<h4>Graph Menu</h4>
-<ul>
-<li><a href="#intro">Introduction</a></li>
-<li><a href="#reset">Reset Graph</a></li>
-<li><a href="#hide">Hide/Show/Delete Graph</a></li>
-<li><a href="#info">Data Info</a></li>
-<li><a href="#save">Save plot Image</a></li>
-<li><a href="#savedata">Save Data</a></li>
-<li><a href="#drag">Drag plot</a></li>
-<li><a href="#zoom">Zoom In/Out</a></li>
-<li><a href="#remove">Remove Data</a></li>
-<li><a href="#scale">Change Scale</a></li>
-<li><a href="#linearfit">Linear Fit</a></li>
-<li><a href="#modify">Other Graph Modifications</a></li>
-</ul>
-
-<h5><a name="intro">Introduction</a></h5>
-<p> 
-	Locating the pointer and right-clicking on a data/theory plot will bring a context menu.
-	On the menu, select a menu item. 
-</p>
-
-<h5><a name="reset">Reset Graph</a></h5>
-<p>
-	To reset the graph's axis range, right click on the plot and the context menu pops-up.
-	Select <b>Reset Graph</b> and the plot will take its initial range. 
-	Also the 'home' icon in tool bar will do the same.
-</p>
-
-<h5><a name="hide">Hide/Show/Delete Graph</a></h5>
-<p>
-	To Hide, click the Hide (bar) button in the tool bar.<br>
-	To Show, select the the 'Show' menuitem in the 'Graph' menu in the menu bar.<br>
-	To Delete, click the 'x' button in the title bar.<br>
-	Note: If a residuals graph (in Fitting) is hidden, it will not show up after computation.
-</p>
-
-<h5><a name="save"> Save Plot Image</a></h5>
-<p>
-	Right click on plot. Context menu will pop-up select save image [file name].A dialog
-	window opens and write a the name of the file to save and click on <b>Save Image.</b>
-</p>
-
-<h5><a name="info"> Data Info</a></h5>
-<p>
-	From the context menu, select 'Data Info' to see the data information dialog panel.
-</p>
-
-<h5><a name="savedata"> Save Data</a></h5>
-<p>
-	From the context menu, select 'Save points as a file' for 1D, or 'Save as a file(DAT)'
-	for 2D. Note that two formats, txt and xml, are available in 1D saving.
-</p>
-
-
-<h5><a name="drag"> Drag Plot</a></h5>
-<p>
-Select the <b>crossed arrows</b>  button on the plot panel <b>toolbar </b> to drag the plot.
-To disable dragging mode, unselect the same button on the toolbar.
-</p>
-
-<h5><a name="remove">Remove data from plot</a></h5>
-<p>
-	Highlight the plot and the context menu appears.Select <b>remove [file name]</b>.
-	The plot selected will disappear.
-</p>
-
-<h5><a name="zoom">Zoom In/Out</a></h5>
-<p>
- Select the <b>rectangle</b>  button on the plot panel <b>toolbar </b> to zoom in
- a region of the plot.
-</p>
-<p>
-To disable zoom mode, unselect the same button on the toolbar. 
-After zoom in a region, select <b>left arrow</b> or <b>right arrow</b>button on the toolbar
-to set the graph the the previous size.
-If a mouse wheel button is available, <b>zoom in/out</b> by scrolling the mouse wheel
- ( see 'Key combination' help for details).
-</p>
-<h5><a name="scale">Change Scale</a></h5>
-<p>
-	If the loaded data is a 1-D data.Changing scale or Data Representation will work as
-	followed:<b>right click</b> on the plot window.
-	A context menu pops-up  and select <b>Change Scale</b>. A dialog window titled<b>
-	select the scale of the graph</b> will pop-up then change the <b>x</b>, the <b>y</b>
-	and the <b>view </b> values as wish.
-	The 'view' option includes the axis scale short-cuts such as Linear, Guinier, Cross-sectional (XC)
-	Guinier, and Porod plot scale.  For a proper data set, these axis scales can be used to estimate 
-	Rg, Rod diameter, or Backgroud of neutron scattering data respectively (via 'Linear Fit'; see below).
-	<br>
-	For a 2D image, <b>Right click</b> on the image to pop-up the context
-	menu. Select <Toggle linear/Log scale> to switch from linear to log scale. The scale 
-	selected is printed on the statusbar.
-	
-</p>
-
-<h5><a name="linearfit">Linear Fit</a></h5>
-<p>
-	Linear fit is to perform a line model fitting keeping the scale of the plot. 
-	Highlight data to fit. 
-	From the context menu
-	select <b> Linear Fit</b>.A dialog window appears.
-	Change model initial parameters, data limits
-	and hit <b> fit</b> button. 
-	New parameters values are displayed and the line with the new 
-	parameters is added to the plot.
-	Especially for Guinier, XC Guinier, and Porod plot scale, this 'Linear Fit' will provides Rg, 
-	Rod diameter, and background, respectively.  The following figure shows an example for the Guinier scale. 
-	</p>
-	<br>
-	<img src="guinier_fit.png" /><br>
-	<br>
-
-<h5><a name="modify">Other Graph Modifications</a></h5>
-<p>
-	Some custom modifications of the symbols, text, axis, etc of the graph are provided
-</p>
-</body>
-</html>
Index: src/sas/guiframe/media/averaging_help.html
===================================================================
--- src/sas/guiframe/media/averaging_help.html	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,107 +1,0 @@
-<html>
-<body>
-
-<h4>2D Data Averaging</h4>
-<ul>
-<li><a href="#Description">Description</a></li>
-<li><a href="#How to use">How to Average? </a></li>
-<p> Available averagings: </p>
-<li><a href="#Circular Average">Perform Circular Average</a></li>
-<li><a href="#Masked Average">Masked Circular Average</a></li>
-<li><a href="#Sector"> Sector [Q view]</a></li>
-<li><a href="#Annulus"> Annulus [Phi view]</a></li>
-<li><a href="#Box sum"> Box sum</a></li>
-<li><a href="#Box averaging in Qx"> Box averaging in Qx</a></li>
-<li><a href="#Box averaging in Qy"> Box averaging in Qy</a></li>
-
-</ul>
-<h5><a name="Description">Description</a></h5>
-<p>
- This feature allows you to perform different types of averages on your data,
- and allows you to see what regions of the detector will contribute to 
- the average. 
- The region to be averaged will be drown and can be modified by dragging the lines around. 
-</p>
-
-
-<h5><a name="How to use">How to Average?</a></h5>
-<p>
-Right click on 2D data for the context menu to appear. Select one type of averages
-among <b>"sector [Q view]", "Annulus [Phi view]", "Box sum", "Box averaging in Qx ",
-"box averaging on Qy","Perform circular Average".</b>
-</p> 
-<p>
-A slicer will appear except for <b> "Perform circular Average"</b>
-that you can drag by clicking on a slicer 's marker. 
- When the marker is highlighted in red , it means that the slicer can change size.You can
- also move some of the slicer by simply drag its side when highlighted in red.
- the slicer size will be reset to its previous size if the user try to select a region greater 
- than the size of the data.
- 
-</p>
- <p>The user can also select a region to average when a slicer has been selected already by <b>right 
- clicking </b> on the context menu and selecting <b>Edit Slicer Parameters</b>. The dialog window 
- will appears and the user can enter values to selected a region or selected numbers of points to 
- plot <b>nbins</b>.
-</p>
- 
-<p>
- For <b>Box sum</b> , when the user selects this option, a new panel is created containing 
- the result of average of the sum of every pixels contains on  that data.The user can also enter 
- values to select a region.
-</p>
-
-<h5><a name="Circular Average">Perform Circular Average</a></h5>
-<p>
-It will perform and average in constant q-rings around the (x,y)
- pixel location of the beam center. 
-</p>
-
-
-<h5><a name="Masked Average">Masked Circular Average</a></h5>
-<p>
-This operation is same as 'Perform Circular Average' except that the masked region is excluded if masked.
-</p>
-
-<h5><a name="Sector">Sector [Q view]</a></h5>
-<p>
-It averages in constant q-arcs. The width of the sector
- is specified in degrees (+/- delta phi) each direction from the central angle (phi).
-</p>
-
-<h5><a name="Annulus"> Annulus [Phi view]</a></h5>
-<p>
-It performs an average between two q-values centered in (0,0),
- and averaged over a width of a specified number of pixels.
- The data is returned as a function of angle (phi) in degrees. 
- Moving one circle of this slicer
- to radius of zero corresponding to a circular averaging on radius qmax , 
- the outer circle.
-  The angle zero starts from the positive x-axis direction.
-</p>
-
-<h5><a name="Box sum"> Box sum</a></h5>
-<p>
-Perform the sum of counts in a 2D region of interest.When editing the slicer ,the user can 
-enter the length and the width the rectangle slicer and the coordinates of the center of this
-rectangle. 
-</p>
-<h5><a name="Box averaging in Qx"> Box averaging in Qx</a></h5>
-<p>
-Computes average I(Qx) for a region of interest. When editing the slicer ,the user can 
-control the length and the width the rectangle slicer. 
-The averaged output is calculated from the constant bins with rectangular shape.
-The resultant q values are nominal values, i.e., the central values of each bins on the x-axis.
-
-</p>
-<h5><a name="Box averaging in Qy"> Box averaging in Qy</a></h5>
-<p>
- Computes average I(Qy) for a region of interest.When editing the slicer ,the user can 
-control the length and the width the rectangle slicer. 
-The averaged output is calculated from the constant bins with rectangular shape.
-The resultant q values are nominal values, i.e., the central values of each bins on the y-axis.
-</p>
-
-</body>
-</html>
-
Index: src/sas/guiframe/media/change_scale_help.html
===================================================================
--- src/sas/guiframe/media/change_scale_help.html	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,16 +1,0 @@
-<html>
-<body>
-<h4>Change scale</h4>
-<p>
-	If the loaded data is a 1-D data.Changing scale or Data Representation will work as
-	followed:<b>right click</b> on the plot window.
-	A context menu pops-up  and select <b>Change Scale</b>. A dialog window titled<b>
-	select the scale of the graph</b> will pop-up then change the <b>x</b>, the <b>y</b>
-	and the <b>view </b> values as wish.
-	If the loaded data  is an image.<b>Right click</b> on the image to pop-up the context
-	menu. Select <Toggle linear/Log scale> to switch from linear to log scale. The scale 
-	selected is printed on the statusbar.
-	
-</p>
-</body>
-</html>
Index: src/sas/guiframe/media/data_explorer_help.html
===================================================================
--- src/sas/guiframe/media/data_explorer_help.html	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,101 +1,0 @@
-<html>
-<body>
-
-<h4>Data Explorer Options</h4>
-<ul>
-<li><a href="#intro">Introduction</a></li>
-<li><a href="#load">Load data</a></li>
-<li><a href="#handy">Handy menu</a></li>
-<li><a href="#active">Activate data</a></li>
-<li><a href="#remove">Remove data</a></li>
-<li><a href="#append">Append plot to graph</a></li>
-<li><a href="#new">Create new plot</a></li>
-<li><a href="#freeze">Freeze theory</a></li>
-<li><a href="#send">Send data to applications</a></li>
-</ul>
-
-<h5><a name="intro"><font color="blue">Introduction</font></a></h5>
-<p> 
-<b>Data Explorer</b> is a panel that allows the user more interactions with
-data. Some functionalities provided by the Data Explorer are also available
-through the context menu of plot panels or other menus of the applications.Under 
-menu <b>View</b> of the menubar, Data explorer can be toggled between Show and Hide 
-by clicking the menu <b>Show/Hide Data Explorer</b>. 
-</p>
-<p><b><font size=2>IMPORTANT!</font></b> When Data explorer is hidden, all the data loaded will
-be sent directly to the current active application, if possible. When data Explorer is shown
-data go first to the Data Explorer for the user to handle them later.
-</p>
-
-<h5><a name="load"><font color="blue">Load data</font></a></h5>
-<p>
-To Load data, click the button <b>Load Data</b>, then select one or more (holding Ctrl key)
-files to load into the application. In
-the list, the <b>Data</b> will be displayed as the name
-of each selected file.
- Expending this data by clicking the <b>+</b> symbol
-will display available information about the data such as data title if exists.
-</p>
-
-
-<h5><a name="handy"><font color="blue">Handy menu</font></a></h5>
-<p>
-For a quick Data-info/Save/Plot/3d-plot(2d only)/Edit-mask(2d only), high-light the data/theory,
- right-click, and select a proper item from the context menu.
- <br>
-<img src="hand_menu.png"/>
-</p>
-
-<h5><a name="active"><font color="blue">Activate data</font></a></h5>
-<p>
-To interact with data, check a data label and click on a button. Checking Data 
-make them active  for the button operation. Unchecking Data labels will
-deactivate them.
-</p>
-<p>
-There is a combo box labeled <b> Selection Options</b> that allows to activate 
-or select multiple data simultaneously. 
-</p>
-
-<h5><a name="remove"><font color="blue">Remove data</font></a></h5>
-<p>
-Remove data button  remove all reference of this data into the application.
-</p>
-<p>
-<font size=2><b>WARNING!</b></font> Remove data will stop any jobs 
-currently using the selected data.
-</p>
-
-<h5><a name="append"><font color="blue">Append plot to graph</font></a></h5>
-<p>
-Click on the button <b>Append To</b> to append selected Data to a plot panel on
-focus. Next to this button is a combo box containing available panels names. 
-Selecting a name from this combo box will set  the corresponding lot panel on 
-focus. If not plot panel is available, the combo box and button will be disable.
-2D Data cannot be appended to any plot panels . This operation can only be 
-performed on 1D data and plot panels currently containing 1D data.
-</p>
-
-<h5><a name="new"><font color="blue">Create new plot</font></a></h5>
-<p>
-Click on <b>New Plot</b> button to create a new plot panel where selected data 
-will be plotted.
-</p>
-
-<h5><a name="freeze"><font color="blue">Freeze theory</font></a></h5>
-<p>
-<b>Freeze Theory</b> button generate Data from selected theory. This operation 
-can only be performed when theory labels are selected. 
-</p>
-
-<h5><a name="send"><font color="blue">Send to application</font></a></h5>
-<p>
-Click on the button <b>Send To</b> to send Data to the current active control page.
-One of the single/batch mode can be selected only for Fitting. The batch mode provides
-serial (batch) fitting with one model, i.e., fitting one data by another data.
-Note that only the Fitting allows more that one data to be sent.
-
-</p>
-
-</body>
-</html>
Index: src/sas/guiframe/media/data_explorer_help.rst
===================================================================
--- src/sas/guiframe/media/data_explorer_help.rst	(revision 0d66541cf69270c2b833e4f21df2f2d3fed2cd9c)
+++ src/sas/guiframe/media/data_explorer_help.rst	(revision 23a9beb149c5d0f661ae1295aede00e83e311057)
@@ -1,3 +1,139 @@
-..data_explorer_help.rst
+.. data_explorer_help.rst
 
-Placeholder for data explorer help
+.. This is a port of the original SasView html help file to ReSTructured text
+.. by S King, ISIS, during SasView CodeCamp-III in Feb 2015.
+
+Loading Data
+============
+
+Introduction_
+
+Load_Data_
+
+Handy_Menu_
+
+Activate_Data_
+
+Remove_Data_
+
+Append_Plot_to_Graph_
+
+Create_New_Plot_
+
+Freeze_Theory_
+
+Send_Data_to_Applications_
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Introduction:
+
+Introduction
+------------
+
+*Data Explorer* is a panel that allows the user more interactions with data. 
+Some functionalities provided by the Data Explorer are also available through 
+the context menu of plot panels or other menus of the applications.Under menu 
+*View*  of the menubar, Data explorer can be toggled between Show and Hide by 
+clicking the menu *Show/Hide Data Explorer* .
+
+*IMPORTANT!*  When Data explorer is hidden, all the data loaded will be sent 
+directly to the current active application, if possible. When data Explorer is 
+shown data go first to the Data Explorer for the user to handle them later.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Load_Data:
+
+Load Data
+---------
+
+To Load data, click the button *Load Data* , then select one or more (holding 
+Ctrl key) files to load into the application. In the list, the *Data*  will be 
+displayed as the name of each selected file. Expending this data by clicking 
+the *+*  symbol will display available information about the data such as data 
+title if exists.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Handy_Menu:
+
+Handy Menu
+----------
+
+For a quick Data-info/Save/Plot/3d-plot(2d only)/Edit-mask(2d only), 
+high-light the data/theory, right-click, and select a proper item from the 
+context menu.
+
+.. image:: hand_menu.png
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Activate_Data:
+
+Activate Data
+-------------
+
+To interact with data, check a data label and click on a button. Checking Data 
+make them active for the button operation. Unchecking Data labels will 
+deactivate them.
+
+There is a combo box labeled *Selection Options*  that allows to activate or 
+select multiple data simultaneously.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Remove_Data:
+
+Remove Data
+-----------
+
+Remove data button remove all reference of this data into the application.
+
+*WARNING!* Remove data will stop any jobs currently using the selected data.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Append_Plot_to_Graph:
+
+Append Plot to Graph
+--------------------
+
+Click on the button *Append To*  to append selected Data to a plot panel on 
+focus. Next to this button is a combo box containing available panels names. 
+Selecting a name from this combo box will set the corresponding lot panel on 
+focus. If not plot panel is available, the combo box and button will be 
+disable. 2D Data cannot be appended to any plot panels . This operation can 
+only be performed on 1D data and plot panels currently containing 1D data.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Create_New_Plot:
+
+Create New Plot
+---------------
+
+Click on *New Plot*  button to create a new plot panel where selected data 
+will be plotted.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Freeze_Theory:
+
+Freeze Theory
+-------------
+
+*Freeze Theory*  button generate Data from selected theory. This operation can 
+only be performed when theory labels are selected.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Send_Data_to_Applications:
+
+Send to Application
+-------------------
+
+Click on the button *Send To*  to send Data to the current active control 
+page. One of the single/batch mode can be selected only for Fitting. The batch 
+mode provides serial (batch) fitting with one model, i.e., fitting one data by 
+another data. Note that only the Fitting allows more that one data to be sent.
Index: src/sas/guiframe/media/graph_help.rst
===================================================================
--- src/sas/guiframe/media/graph_help.rst	(revision 0d66541cf69270c2b833e4f21df2f2d3fed2cd9c)
+++ src/sas/guiframe/media/graph_help.rst	(revision 98b30b46ac241d857a5698740991daae2c25c3c2)
@@ -1,3 +1,359 @@
-..graph_help.rst
-
-Placeholder for graph help
+.. graph_help.rst
+
+.. This is a port of the original SasView html help file to ReSTructured text
+.. by S King, ISIS, during SasView CodeCamp-III in Feb 2015.
+
+Plotting Data/Models
+====================
+
+Graph_Menu_
+
+2D_Data_Averaging_
+
+Key_Sequences_
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Graph_Menu:
+
+Graph Menu
+----------
+
+Invoking_the_Graph_Menu_
+
+Reset_Graph_
+
+Hide_Show_Delete_Graph_
+
+Data_Info_
+
+Save_Plot_Image_
+
+Save_Data_
+
+Drag_Plot_
+
+Zoom_In_Out_
+
+Remove_Data_from_Plot_
+
+Change_Scale_
+
+Linear_Fit_
+
+Other_Graph_Modifications_
+
+.. _Invoking_the_Graph_Menu:
+
+Introduction
+------------
+
+Locating the pointer and right-clicking on a data/theory plot will bring a 
+context menu. On the menu, select a menu item.
+
+.. _Reset_Graph:
+
+Reset Graph
+-----------
+
+To reset the graph's axis range, right click on the plot and the context menu 
+pops-up. Select *Reset Graph*  and the plot will take its initial range. Also 
+the 'home' icon in tool bar will do the same.
+
+.. _Hide_Show_Delete_Graph:
+
+Hide/Show/Delete Graph
+----------------------
+
+To Hide, click the Hide (bar) button in the tool bar.To Show, select the the 
+'Show' menu item in the 'Graph' menu in the menu bar.To Delete, click the 'x' 
+button in the title bar.
+
+Note: If a residuals graph (in Fitting) is hidden, it will not show up after 
+computation.
+
+.. _Data_Info:
+
+Data Info
+---------
+
+From the context menu, select 'Data Info' to see the data information dialog
+panel.
+
+.. _Save_Plot_Image:
+
+Save Plot Image
+---------------
+
+Right click on plot. Context menu will pop-up select save image [file name].
+A dialog window opens and write a the name of the file to save and click on 
+*Save Image.*
+
+.. _Save_Data:
+
+Save Data
+---------
+
+From the context menu, select 'Save points as a file' for 1D, or 'Save as a 
+file(DAT)' for 2D. Note that two formats, txt and xml, are available in 1D 
+saving.
+
+.. _Drag_Plot:
+
+Drag Plot
+---------
+
+Select the *crossed arrows*  button on the plot panel *toolbar*  to drag the 
+plot. To disable dragging mode, unselect the same button on the toolbar.
+
+.. _Zoom_In_Out:
+
+Zoom In/Out
+-----------
+
+Select the *rectangle*  button on the plot panel *toolbar*  to zoom in a
+region of the plot.
+
+To disable zoom mode, unselect the same button on the toolbar. After zoom in
+a region, select *left arrow*  or *right arrow*  button on the toolbar to set
+the graph the the previous size. If a mouse wheel button is available,
+*zoom in/out*  by scrolling the mouse wheel (see Key_Sequences_ help for
+details).
+
+.. _Remove_Data_from_Plot:
+
+Remove Data from Plot
+---------------------
+
+Highlight the plot and the context menu appears.Select *remove [file name]*.
+The plot selected will disappear.
+
+.. _Change_Scale:
+
+Change Scale
+------------
+
+If the loaded data is a 1-D data changing scale or data representation will 
+work as follows. *Right click* on the plot window. A context menu pops-up and 
+select *Change Scale* . A dialog window titled *select the scale of the graph* 
+will pop-up then change the *x* , the *y*  and the *view*  values as wish.
+
+The 'view' option includes the axis scale short-cuts such as Linear, Guinier, 
+Cross-sectional (XC) Guinier, and Porod plot scale. For a proper data set, 
+these axis scales can be used to estimate Rg, Rod diameter, or Background of 
+neutron scattering data respectively (via 'Linear Fit'; see below). For a 2D 
+image, *Right click*  on the image to pop-up the context menu. Select to 
+switch from linear to log scale. The scale selected is printed on the status 
+bar.
+
+If the loaded data is an image. *Right click*  on the image to pop-up the
+context menu. Select to switch from linear to log scale. The scale selected is
+printed on the status bar.
+
+.. _Linear_Fit:
+
+Linear Fit
+----------
+
+Linear fit is to perform a line model fitting keeping the scale of the plot.
+Highlight data to fit. From the context menu select *Linear Fit* . A dialog
+window appears. Change model initial parameters, data limits and hit *fit*
+button. New parameters values are displayed and the line with the new
+parameters is added to the plot. Especially for Guinier, XC Guinier, and
+Porod plot scale, this 'Linear Fit' will provides Rg, Rod diameter, and
+background, respectively. The following figure shows an example for the
+Guinier scale.
+
+.. image:: guinier_fit.png
+
+.. _Other_Graph_Modifications:
+
+Other Graph Modifications
+-------------------------
+
+Some custom modifications of the symbols, text, axis, etc of the graph are 
+provided.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _2D_Data_Averaging:
+
+2D Data Averaging
+-----------------
+
+Principle_
+
+How_to_Average_
+
+Available_Averagings_
+
+Unmasked_Circular_Average_
+
+Masked_Circular_Average_
+
+Sector_Average_
+
+Annular_Average_
+
+Box_Sum_
+
+Box_Averaging_in_Qx_
+
+Box_Averaging_in_Qy_
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. Principle: 
+
+Principle
+---------
+
+This feature allows you to perform different types of averages on your data, 
+and allows you to see what regions of the detector will contribute to the 
+average. The region to be averaged will be drown and can be modified by 
+dragging the lines around.
+
+.. _How_to_Average:
+
+How to Average
+--------------
+
+Right click on 2D data for the context menu to appear. Select one type of 
+averages among *"sector [Q view]", "Annulus [Phi view]", "Box sum", "Box 
+averaging in Qx ", "box averaging on Qy","Perform circular Average".*
+
+A slicer will appear except for *"Perform circular Average"*  that you can 
+drag by clicking on a slicer 's marker. When the marker is highlighted in red, 
+it means that the slicer can change size.You can also move some of the slicer 
+by simply drag its side when highlighted in red. the slicer size will be reset 
+to its previous size if the user try to select a region greater than the size 
+of the data.
+
+The user can also select a region to average when a slicer has been selected 
+already by *right clicking*  on the context menu and selecting *Edit Slicer 
+Parameters* . The dialog window will appears and the user can enter values to 
+selected a region or selected numbers of points to plot *nbins* .
+
+For *Box sum* , when the user selects this option, a new panel is created 
+containing the result of average of the sum of every pixels contains on that 
+data.The user can also enter values to select a region.
+
+.. _Available_Averagings:
+
+Available Averagings
+--------------------
+
+Some different types of averaging are provided for.
+
+.. _Unmasked_Circular_Average:
+
+Unmasked Circular Average
+-------------------------
+
+This operation will perform and average in constant q-rings around the (x,y) pixel
+location of the beam center.
+
+.. _Masked_Circular_Average:
+
+Masked Circular Average
+-----------------------
+
+This operation is same as 'Masked Circular Average' except that the masked
+region is excluded if masked.
+
+.. _Sector_Average:
+
+Sector Average [Q View]
+-----------------------
+
+This operation averages in constant q-arcs. The width of the sector is specified in
+degrees (+/- delta phi) each side of the central angle (phi).
+
+.. _Annular_Average:
+
+Annular Average [Phi View]
+--------------------------
+
+It performs an average between two q-values centered in (0,0), and averaged 
+over a width of a specified number of pixels. The data is returned as a 
+function of angle (phi) in degrees. Moving one circle of this slicer to 
+radius of zero corresponding to a circular averaging on radius qmax , the 
+outer circle. The angle zero starts from the positive x-axis direction.
+
+.. _Box_Sum:
+
+Box Sum
+-------
+
+Perform the sum of counts in a 2D region of interest.When editing the slicer, 
+the user can enter the length and the width the rectangle slicer and the 
+coordinates of the center of this rectangle.
+
+.. _Box_Averaging_in_Qx:
+
+Box Averaging in Qx
+-------------------
+
+Computes average I(Qx) for a region of interest. When editing the slicer, the 
+user can control the length and the width the rectangle slicer. The averaged 
+output is calculated from the constant bins with rectangular shape. The 
+resultant q values are nominal values, i.e., the central values of each bins 
+on the x-axis.
+
+.. _Box_Averaging_in_Qy:
+
+Box Averaging in Qy
+-------------------
+
+Computes average I(Qy) for a region of interest.When editing the slicer, the 
+user can control the length and the width the rectangle slicer. The averaged 
+output is calculated from the constant bins with rectangular shape. The 
+resultant q values are nominal values, i.e., the central values of each bins 
+on the y-axis.
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Key_Sequences:
+
+Key Sequences
+-------------
+
+Floating_Panel_
+
+Context_Menu_
+
+Zoom_
+
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+
+.. _Floating_Panel:
+
+Floating Panel
+--------------
+
+For a graph panel to float on the top of the SV window:
+
+Press the *Ctrl(Cmd on MAC) key*  on dragging and placing a panel. Or if you 
+want to make all plot panels float, select 'Float' from Graph/Preperences in 
+the menu bar. Otherwise choose 'Dock'.
+
+.. _Context_Menu:
+
+Graph Context Menu
+------------------
+
+To get the graph context menu to print, copy, save data, (2D)average, etc, 
+*locate the mouse point on the plot to highlight and *(Mouse) Right Click* 
+to bring up the full menu.
+
+.. _Zoom:
+
+Zoom In/Out
+-----------
+
+To Zoom in or out the full plot, *locate the mouse point inside the graph 
+which will be the center of the zooming, then *rotate MouseWheel*.
+
+*To Zoom in or out the plot in x or y direction, *locate (and click) the 
+mouse point near x (or y) axis just outside of the graph and then *rotate 
+MouseWheel* .* Note that this works only on the 1D plots.
Index: src/sas/guiframe/media/key_help.html
===================================================================
--- src/sas/guiframe/media/key_help.html	(revision 794922220f2fb3b23dd08c648aabf87b4850596c)
+++ 	(revision )
@@ -1,40 +1,0 @@
-<html>
-<body>
-
-<h4>Key Combination</h4>
-<ul>
-<li><a href="#Float">Floating Panel</a></li>
-<li><a href="#GraphMenu">Graph Context Menu</a></li>
-<li><a href="#Zoom">Zoom In & Out</a></li>
-</ul>
-
-<h5><a name="Float">Floating Panel</a></h5>
-<p>
-<h6>For a graph panel to float on the top of the SV window:</h6></p>
-<p> Press the <b>Ctrl(Cmd on MAC) key</b> on dragging and placing a panel.
-Or if you want to make all plot panels float, select 'Float' from Graph/Preperences
-in the menu bar. Otherwise choose 'Dock'.</p>
-
-<p>
-<h5><a name="GraphMenu">Graph Context Menu</a></h5>
-<p>
-<h6>To get the graph context menu to print, copy, save data, (2D)average, etc.:</h6></p>
-<p> <b>Locate the mouse point on the plot to highlight and 
-<b>(Mouse) Right Click</b> to bring up the full menu.</p>
-
-<p>
-<h5><a name="Zoom">Zoom In and Out</a></h5>
-<p>
-<h6>To Zoom in or out the full plot:</h6></p>
-<p> <b>Locate the mouse point inside the graph which will be the center of the zooming,
-then <b>rotate MouseWheel</b>.</p>
-<p>
-<h6>To Zoom in or out the plot in x or y direction:</h6></p>
-<p> <b>Locate (and click) the mouse point near x (or y) axis just outside of the graph 
-and then <b>rotate MouseWheel</b>.</p>
-<p> Note that this works only on the 1D plots.</p>
-
-
-</body>
-</html>
-